diff -ruN vdr-1.7.22/epg.c vdr-1.7.23/epg.c
--- vdr-1.7.22/epg.c	2011-02-25 16:16:05.000000000 +0100
+++ vdr-1.7.23/epg.c	2012-01-12 15:31:46.000000000 +0100
@@ -7,7 +7,7 @@
  * Original version (as used in VDR before 1.3.0) written by
  * Robert Schneider <Robert.Schneider@web.de> and Rolf Hakenes <hakenes@hippomi.de>.
  *
- * $Id: epg.c 2.7 2011/02/25 15:16:05 kls Exp $
+ * $Id: epg.c 2.9 2012/01/12 14:31:46 kls Exp $
  */
 
 #include "epg.h"
@@ -828,10 +828,17 @@
 
 Final:
 
-  // VDR can't usefully handle newline characters in the title and shortText of EPG
+  // VDR can't usefully handle newline characters in the title, shortText or component description of EPG
   // data, so let's always convert them to blanks (independent of the setting of EPGBugfixLevel):
   strreplace(title, '\n', ' ');
   strreplace(shortText, '\n', ' ');
+  if (components) {
+     for (int i = 0; i < components->NumComponents(); i++) {
+         tComponent *p = components->Component(i);
+         if (p->description)
+            strreplace(p->description, '\n', ' ');
+         }
+     }
   /* TODO adapt to UTF-8
   // Same for control characters:
   strreplace(title, '\x86', ' ');
@@ -1022,10 +1029,15 @@
 
 void cSchedule::Cleanup(time_t Time)
 {
-  cEvent *Event;
-  while ((Event = events.First()) != NULL) {
-        if (!Event->HasTimer() && Event->EndTime() + Setup.EPGLinger * 60 + 3600 < Time) // adding one hour for safety
-           DelEvent(Event);
+  cEvent *Event = events.First();
+  while (Event) {
+        if (Event->HasTimer())
+           Event = (cEvent *)Event->Next();
+        else if (Event->EndTime() + Setup.EPGLinger * 60 + 3600 < Time) { // adding one hour for safety
+           cEvent *e = Event;
+           Event = (cEvent *)Event->Next();
+           DelEvent(e);
+           }
         else
            break;
         }
diff -ruN vdr-1.7.22/font.c vdr-1.7.23/font.c
--- vdr-1.7.22/font.c	2011-03-28 18:29:51.000000000 +0200
+++ vdr-1.7.23/font.c	2012-01-13 10:43:22.000000000 +0100
@@ -6,7 +6,7 @@
  *
  * BiDi support by Osama Alrawab <alrawab@hotmail.com> @2008 Tripoli-Libya.
  *
- * $Id: font.c 2.8 2011/03/28 16:29:51 kls Exp $
+ * $Id: font.c 2.9 2012/01/13 09:43:22 kls Exp $
  */
 
 #include "font.h"
@@ -508,25 +508,27 @@
 #ifdef BIDI
 cString cFont::Bidi(const char *Ltr)
 {
-  fribidi_set_mirroring(true);
-  fribidi_set_reorder_nsm(false);
-  FriBidiCharSet fribidiCharset = FRIBIDI_CHAR_SET_UTF8;
-  int LtrLen = strlen(Ltr);
-  FriBidiCharType Base = FRIBIDI_TYPE_L;
-  FriBidiChar *Logical = MALLOC(FriBidiChar, LtrLen + 1) ;
-  int RtlLen = fribidi_charset_to_unicode(fribidiCharset, const_cast<char *>(Ltr), LtrLen, Logical);
-  FriBidiChar *Visual = MALLOC(FriBidiChar, LtrLen + 1) ;
-  char *Rtl = NULL;
-  bool ok = fribidi_log2vis(Logical, RtlLen, &Base, Visual, NULL, NULL, NULL);
-  if (ok) {
-     fribidi_remove_bidi_marks(Visual, RtlLen, NULL, NULL, NULL);
-     Rtl = MALLOC(char, RtlLen * 4 + 1);
-     fribidi_unicode_to_charset(fribidiCharset, Visual, RtlLen, Rtl);
+  if (cCharSetConv::SystemCharacterTable()) { // bidi requires UTF-8
+     fribidi_set_mirroring(true);
+     fribidi_set_reorder_nsm(false);
+     FriBidiCharSet fribidiCharset = FRIBIDI_CHAR_SET_UTF8;
+     int LtrLen = strlen(Ltr);
+     FriBidiCharType Base = FRIBIDI_TYPE_L;
+     FriBidiChar *Logical = MALLOC(FriBidiChar, LtrLen + 1) ;
+     int RtlLen = fribidi_charset_to_unicode(fribidiCharset, const_cast<char *>(Ltr), LtrLen, Logical);
+     FriBidiChar *Visual = MALLOC(FriBidiChar, LtrLen + 1) ;
+     char *Rtl = NULL;
+     bool ok = fribidi_log2vis(Logical, RtlLen, &Base, Visual, NULL, NULL, NULL);
+     if (ok) {
+        fribidi_remove_bidi_marks(Visual, RtlLen, NULL, NULL, NULL);
+        Rtl = MALLOC(char, RtlLen * 4 + 1);
+        fribidi_unicode_to_charset(fribidiCharset, Visual, RtlLen, Rtl);
+        }
+     free(Logical);
+     free(Visual);
+     if (ok)
+        return cString(Rtl, true);
      }
-  free(Logical);
-  free(Visual);
-  if (ok)
-     return cString(Rtl, true);
   return cString(Ltr);
 }
 #endif
diff -ruN vdr-1.7.22/libsi/descriptor.c vdr-1.7.23/libsi/descriptor.c
--- vdr-1.7.22/libsi/descriptor.c	2011-06-15 23:26:00.000000000 +0200
+++ vdr-1.7.23/libsi/descriptor.c	2012-01-11 12:35:17.000000000 +0100
@@ -6,7 +6,7 @@
  *   the Free Software Foundation; either version 2 of the License, or     *
  *   (at your option) any later version.                                   *
  *                                                                         *
- *   $Id: descriptor.c 2.2 2011/06/15 21:26:00 kls Exp $
+ *   $Id: descriptor.c 2.4 2012/01/11 11:35:17 kls Exp $
  *                                                                         *
  ***************************************************************************/
 
@@ -876,6 +876,52 @@
    return s->descriptor_tag_extension;
 }
 
+void T2DeliverySystemDescriptor::Parse() {
+   int offset=0;
+   data.setPointerAndOffset<const descr_t2_delivery_system>(s, offset);
+   extended_data_flag = s->descriptor_length > 0x04;
+}
+
+int T2DeliverySystemDescriptor::getExtendedDataFlag() const {
+  return extended_data_flag;
+}
+
+int T2DeliverySystemDescriptor::getExtensionDescriptorTag() const {
+   return s->descriptor_tag_extension;
+}
+
+int T2DeliverySystemDescriptor::getPlpId() const {
+   return s->plp_id;
+}
+
+int T2DeliverySystemDescriptor::getT2SystemId() const {
+   return HILO(s->t2_system_id);
+}
+
+int T2DeliverySystemDescriptor::getSisoMiso() const {
+   return extended_data_flag ? s->siso_miso : -1;
+}
+
+int T2DeliverySystemDescriptor::getBandwidth() const {
+   return extended_data_flag ? s->bandwidth : -1;
+}
+
+int T2DeliverySystemDescriptor::getGuardInterval() const {
+   return extended_data_flag ? s->guard_interval : -1;
+}
+
+int T2DeliverySystemDescriptor::getTransmissionMode() const {
+   return extended_data_flag ? s->transmission_mode : -1;
+}
+
+int T2DeliverySystemDescriptor::getOtherFrequencyFlag() const {
+   return extended_data_flag ? s->other_frequency_flag : -1;
+}
+
+int T2DeliverySystemDescriptor::getTfsFlag() const {
+   return extended_data_flag ? s->tfs_flag : -1;
+}
+
 int PremiereContentTransmissionDescriptor::getOriginalNetworkId() const {
    return HILO(s->original_network_id);
 }
@@ -1005,8 +1051,14 @@
    return componentTag;
 }
 
+char *MHP_TransportProtocolDescriptor::getUrlBase(char *buffer, int size) {
+   return UrlBase.getText(buffer, size);
+}
+
 void MHP_TransportProtocolDescriptor::Parse() {
    int offset=0;
+   remote=false;
+   componentTag=-1;
    data.setPointerAndOffset<const descr_transport_protocol>(s, offset);
    if (getProtocolId() == ObjectCarousel) {
       const transport_via_oc *oc;
@@ -1021,12 +1073,24 @@
          data.setPointerAndOffset<const transport_via_oc_end>(rem, offset);
          componentTag=rem->component_tag;
       }
-   } else { //unimplemented
-      remote=false;
-      componentTag=-1;
+   } else if (getProtocolId() == HTTPoverInteractionChannel) {
+      const transport_via_http *http;
+      data.setPointerAndOffset<const transport_via_http>(http, offset);
+      UrlBase.setDataAndOffset(data+offset, http->url_base_length, offset);
+
+      // fill URL Extension,
+      UrlExtensionLoop.setData(data+offset, getLength()-offset);
+   } else {
+      //unimplemented
    }
 }
 
+void MHP_TransportProtocolDescriptor::UrlExtensionEntry::Parse() {
+   const descr_url_extension_entry *s;
+   s=data.getData<const descr_url_extension_entry>();
+   UrlExtension.setData(data, s->url_extension_length);
+}
+
 void MHP_DVBJApplicationDescriptor::Parse() {
    applicationLoop.setData(data+sizeof(descr_dvbj_application), getLength()-sizeof(descr_dvbj_application));
 }
@@ -1059,6 +1123,17 @@
    data.setPointerAndOffset<const descr_application_icons_descriptor_end>(s, offset);
 }
 
+char *MHP_SimpleApplicationLocationDescriptor::getLocation(char *buffer, int size) {
+   return location.getText(buffer, size);
+}
+
+void MHP_SimpleApplicationLocationDescriptor::Parse() {
+   int offset=0;
+   const descr_simple_application_location_descriptor *loc;
+   data.setPointerAndOffset<const descr_simple_application_location_descriptor>(loc, offset);
+   location.setDataAndOffset(data+offset, loc->descriptor_length, offset);
+}
+
 int RegistrationDescriptor::getFormatIdentifier() const {
    return HILOHILO(s->format_identifier);
 }
diff -ruN vdr-1.7.22/libsi/descriptor.h vdr-1.7.23/libsi/descriptor.h
--- vdr-1.7.22/libsi/descriptor.h	2011-06-15 23:26:00.000000000 +0200
+++ vdr-1.7.23/libsi/descriptor.h	2012-01-11 12:35:17.000000000 +0100
@@ -6,7 +6,7 @@
  *   the Free Software Foundation; either version 2 of the License, or     *
  *   (at your option) any later version.                                   *
  *                                                                         *
- *   $Id: descriptor.h 2.2 2011/06/15 21:26:00 kls Exp $
+ *   $Id: descriptor.h 2.4 2012/01/11 11:35:17 kls Exp $
  *                                                                         *
  ***************************************************************************/
 
@@ -538,6 +538,25 @@
    const descr_extension *s;
 };
 
+class T2DeliverySystemDescriptor : public Descriptor {
+public:
+   int getExtendedDataFlag() const;
+   int getExtensionDescriptorTag() const;
+   int getPlpId() const;
+   int getT2SystemId() const;
+   int getSisoMiso() const;
+   int getBandwidth() const;
+   int getGuardInterval() const;
+   int getTransmissionMode() const;
+   int getOtherFrequencyFlag() const;
+   int getTfsFlag() const;
+protected:
+   virtual void Parse();
+private:
+   const descr_t2_delivery_system *s;
+   int extended_data_flag;
+};
+
 // Private DVB Descriptor  Premiere.de
 // 0xF2  Content Transmission Descriptor
 // http://dvbsnoop.sourceforge.net/examples/example-private-section.html
@@ -639,17 +658,29 @@
 
 class MHP_TransportProtocolDescriptor : public Descriptor {
 public:
+   class UrlExtensionEntry : public LoopElement {
+   public:
+      virtual int getLength() { return sizeof(descr_url_extension_entry)+UrlExtension.getLength(); }
+      String UrlExtension;
+   protected:
+      virtual void Parse();
+   };
+
    enum Protocol { ObjectCarousel = 0x01, IPviaDVB = 0x02, HTTPoverInteractionChannel = 0x03 };
    int getProtocolId() const;
    int getProtocolLabel() const;
    bool isRemote() const;
    int getComponentTag() const;
+   char *getUrlBase(char *buffer, int size);
+   StructureLoop<UrlExtensionEntry> UrlExtensionLoop;
+
 protected:
    virtual void Parse();
 private:
    const descr_transport_protocol *s;
    bool remote;
    int componentTag;
+   String UrlBase;
 };
 
 class MHP_DVBJApplicationDescriptor : public Descriptor {
@@ -685,6 +716,15 @@
    const descr_application_icons_descriptor_end *s;
 };
 
+class MHP_SimpleApplicationLocationDescriptor : public Descriptor {
+public:
+   char *getLocation(char *buffer, int size);
+protected:
+   virtual void Parse();
+private:
+   String location;
+};
+
 class RegistrationDescriptor : public Descriptor {
 public:
    int getFormatIdentifier() const;
diff -ruN vdr-1.7.22/libsi/headers.h vdr-1.7.23/libsi/headers.h
--- vdr-1.7.22/libsi/headers.h	2011-06-15 23:26:00.000000000 +0200
+++ vdr-1.7.23/libsi/headers.h	2012-01-11 12:35:17.000000000 +0100
@@ -10,7 +10,7 @@
  *   the Free Software Foundation; either version 2 of the License, or     *
  *   (at your option) any later version.                                   *
  *                                                                         *
- *   $Id: headers.h 2.2 2011/06/15 21:26:00 kls Exp $
+ *   $Id: headers.h 2.4 2012/01/11 11:35:17 kls Exp $
  *                                                                         *
  ***************************************************************************/
 
@@ -1839,6 +1839,37 @@
    u_char descriptor_tag_extension               :8;
 };
 
+/* extension 0x04 t2_delivery_system_descriptor */
+
+struct descr_t2_delivery_system {
+   u_char descriptor_tag                         :8;
+   u_char descriptor_length                      :8;
+   u_char descriptor_tag_extension               :8;
+   u_char plp_id                                 :8;
+   u_char t2_system_id_hi                        :8;
+   u_char t2_system_id_lo                        :8;
+#if BYTE_ORDER == BIG_ENDIAN
+   u_char siso_miso                              :2;
+   u_char bandwidth                              :4;
+   u_char reserved                               :2;
+   u_char guard_interval                         :3;
+   u_char transmission_mode                      :3;
+   u_char other_frequency_flag                   :1;
+   u_char tfs_flag                               :1;
+#else
+   u_char reserved                               :2;
+   u_char bandwidth                              :4;
+   u_char siso_miso                              :2;
+   u_char tfs_flag                               :1;
+   u_char other_frequency_flag                   :1;
+   u_char transmission_mode                      :3;
+   u_char guard_interval                         :3;
+#endif
+/* now follow cell_id, frequency_loop_length, centre_frequency,
+   subcell_info_loop_length, cell_id_extension, transposer_frequency
+   fields looping to the end */
+};
+
 /* MHP 0x00 application_descriptor */
 
 #define DESCR_APPLICATION_LEN 3
@@ -1907,6 +1938,11 @@
    /* protocol_id-specific selector bytes follow */
 };
 
+struct descr_url_extension_entry {
+   u_char url_extension_length                   :8;
+   /* URL extension string */
+};
+
 #define TRANSPORT_VIA_OC_LEN 1
 
 struct transport_via_oc {
@@ -1940,6 +1976,12 @@
    u_char component_tag                          :8;
 };
 
+#define TRANSPORT_VIA_HTTP_LEN 1
+
+struct transport_via_http {
+   u_char url_base_length                        :8;
+};
+
 /* 0x03 dvb_j_application_descriptor() */
 
 #define DESCR_DVBJ_APPLICATION_LEN 2
@@ -1991,6 +2033,16 @@
    u_char icon_flags_lo                          :8;
 };
 
+/* 0x15 simple application location descrptor */
+
+#define DESCR_SIMPLE_APPLICATION_LOCATION_LEN 3
+
+struct descr_simple_application_location_descriptor {
+   u_char descriptor_tag                         :8;
+   u_char descriptor_length                      :8;
+   /* inital_path_bytes */
+};
+
 // Private DVB Descriptor  Premiere.de
 // 0xF2  Content Transmission Descriptor
 // http://dvbsnoop.sourceforge.net/examples/example-private-section.html
diff -ruN vdr-1.7.22/libsi/si.c vdr-1.7.23/libsi/si.c
--- vdr-1.7.22/libsi/si.c	2011-12-04 16:06:18.000000000 +0100
+++ vdr-1.7.23/libsi/si.c	2011-12-10 16:47:15.000000000 +0100
@@ -6,7 +6,7 @@
  *   the Free Software Foundation; either version 2 of the License, or     *
  *   (at your option) any later version.                                   *
  *                                                                         *
- *   $Id: si.c 2.5 2011/12/04 15:06:18 kls Exp $
+ *   $Id: si.c 2.6 2011/12/10 15:47:15 kls Exp $
  *                                                                         *
  ***************************************************************************/
 
@@ -690,6 +690,9 @@
          case MHP_DVBJApplicationLocationDescriptorTag:
             d=new MHP_DVBJApplicationLocationDescriptor();
             break;
+         case MHP_SimpleApplicationLocationDescriptorTag:
+            d=new MHP_SimpleApplicationLocationDescriptor();
+            break;
       // 0x05 - 0x0A is unimplemented this library
          case MHP_ExternalApplicationAuthorisationDescriptorTag:
          case MHP_IPv4RoutingDescriptorTag:
diff -ruN vdr-1.7.22/libsi/si.h vdr-1.7.23/libsi/si.h
--- vdr-1.7.22/libsi/si.h	2010-02-13 11:31:34.000000000 +0100
+++ vdr-1.7.23/libsi/si.h	2012-01-11 12:35:17.000000000 +0100
@@ -6,7 +6,7 @@
  *   the Free Software Foundation; either version 2 of the License, or     *
  *   (at your option) any later version.                                   *
  *                                                                         *
- *   $Id: si.h 2.3 2010/02/13 10:31:34 kls Exp $
+ *   $Id: si.h 2.5 2012/01/11 11:35:17 kls Exp $
  *                                                                         *
  ***************************************************************************/
 
@@ -134,6 +134,19 @@
                DTSDescriptorTag = 0x7B,
                AACDescriptorTag = 0x7C,
                ExtensionDescriptorTag = 0x7F,
+ // Extension descriptors
+               ImageIconDescriptorTag = 0x00,
+               CpcmDeliverySignallingDescriptor = 0x01,
+               CPDescriptorTag = 0x02,
+               CPIdentifierDescriptorTag = 0x03,
+               T2DeliverySystemDescriptorTag = 0x04,
+               SHDeliverySystemDescriptorTag = 0x05,
+               SupplementaryAudioDescriptorTag = 0x06,
+               NetworkChangeNotifyDescriptorTag = 0x07,
+               MessageDescriptorTag = 0x08,
+               TargetRegionDescriptorTag = 0x09,
+               TargetRegionNameDescriptorTag = 0x0A,
+               ServiceRelocatedDescriptorTag = 0x0B,
 
  // Defined by ETSI TS 102 812 (MHP)
                // They once again start with 0x00 (see page 234, MHP specification)
@@ -153,6 +166,8 @@
                MHP_PrefetchDescriptorTag = 0x0C,
                MHP_DelegatedApplicationDescriptorTag = 0x0E,
                MHP_ApplicationStorageDescriptorTag = 0x10,
+               MHP_SimpleApplicationLocationDescriptorTag = 0x15,
+               MHP_SimpleApplicationBoundaryDescriptorTag = 0x17,
   // Premiere private Descriptor Tags
                PremiereContentTransmissionDescriptorTag = 0xF2,
 
diff -ruN vdr-1.7.22/menu.c vdr-1.7.23/menu.c
--- vdr-1.7.22/menu.c	2011-12-04 15:52:38.000000000 +0100
+++ vdr-1.7.23/menu.c	2012-01-14 14:06:03.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menu.c 2.34 2011/12/04 14:52:38 kls Exp $
+ * $Id: menu.c 2.35 2012/01/14 13:06:03 kls Exp $
  */
 
 #include "menu.h"
@@ -3114,6 +3114,7 @@
   SetSection(tr("Replay"));
   Add(new cMenuEditBoolItem(tr("Setup.Replay$Multi speed mode"), &data.MultiSpeedMode));
   Add(new cMenuEditBoolItem(tr("Setup.Replay$Show replay mode"), &data.ShowReplayMode));
+  Add(new cMenuEditBoolItem(tr("Setup.Replay$Show remaining time"), &data.ShowRemainingTime));
   Add(new cMenuEditIntItem(tr("Setup.Replay$Resume ID"), &data.ResumeID, 0, 99));
 }
 
@@ -4568,12 +4569,15 @@
            displayReplay->SetTitle(title);
         lastCurrent = lastTotal = -1;
         }
-     if (Total != lastTotal) {
-        displayReplay->SetTotal(IndexToHMSF(Total, false, FramesPerSecond()));
-        if (!Initial)
-           displayReplay->Flush();
-        }
      if (Current != lastCurrent || Total != lastTotal) {
+        if (Setup.ShowRemainingTime || Total != lastTotal) {
+           int Index = Total;
+           if (Setup.ShowRemainingTime)
+              Index = Current - Index;
+           displayReplay->SetTotal(IndexToHMSF(Index, false, FramesPerSecond()));
+           if (!Initial)
+              displayReplay->Flush();
+           }
         displayReplay->SetProgress(Current, Total);
         if (!Initial)
            displayReplay->Flush();
diff -ruN vdr-1.7.22/nit.c vdr-1.7.23/nit.c
--- vdr-1.7.22/nit.c	2011-08-12 16:27:31.000000000 +0200
+++ vdr-1.7.23/nit.c	2012-01-12 09:43:52.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: nit.c 2.6 2011/08/12 14:27:31 kls Exp $
+ * $Id: nit.c 2.9 2012/01/12 08:43:52 kls Exp $
  */
 
 #include "nit.h"
@@ -16,6 +16,9 @@
 #include "libsi/descriptor.h"
 #include "tools.h"
 
+#define DVB_SYSTEM_1 0 // see also dvbdevice.c
+#define DVB_SYSTEM_2 1
+
 cNitFilter::cNitFilter(void)
 {
   numNits = 0;
@@ -134,7 +137,7 @@
                  dtp.SetCoderateH(CodeRates[sd->getFecInner()]);
                  static int Modulations[] = { QAM_AUTO, QPSK, PSK_8, QAM_16 };
                  dtp.SetModulation(Modulations[sd->getModulationType()]);
-                 dtp.SetSystem(sd->getModulationSystem() ? SYS_DVBS2 : SYS_DVBS);
+                 dtp.SetSystem(sd->getModulationSystem() ? DVB_SYSTEM_2 : DVB_SYSTEM_1);
                  static int RollOffs[] = { ROLLOFF_35, ROLLOFF_25, ROLLOFF_20, ROLLOFF_AUTO };
                  dtp.SetRollOff(sd->getModulationSystem() ? RollOffs[sd->getRollOff()] : ROLLOFF_AUTO);
                  int SymbolRate = BCD2INT(sd->getSymbolRate()) / 10;
@@ -242,10 +245,11 @@
                  cDvbTransponderParameters dtp;
                  int Source = cSource::FromData(cSource::stTerr);
                  int Frequency = Frequencies[0] = sd->getFrequency() * 10;
-                 static int Bandwidths[] = { 8000000, 7000000, 6000000, 0, 0, 0, 0, 0 };
+                 static int Bandwidths[] = { 8000000, 7000000, 6000000, 5000000, 0, 0, 0, 0 };
                  dtp.SetBandwidth(Bandwidths[sd->getBandwidth()]);
                  static int Constellations[] = { QPSK, QAM_16, QAM_64, QAM_AUTO };
                  dtp.SetModulation(Constellations[sd->getConstellation()]);
+                 dtp.SetSystem(DVB_SYSTEM_1);
                  static int Hierarchies[] = { HIERARCHY_NONE, HIERARCHY_1, HIERARCHY_2, HIERARCHY_4, HIERARCHY_AUTO, HIERARCHY_AUTO, HIERARCHY_AUTO, HIERARCHY_AUTO };
                  dtp.SetHierarchy(Hierarchies[sd->getHierarchy()]);
                  static int CodeRates[] = { FEC_1_2, FEC_2_3, FEC_3_4, FEC_5_6, FEC_7_8, FEC_AUTO, FEC_AUTO, FEC_AUTO };
@@ -253,7 +257,7 @@
                  dtp.SetCoderateL(CodeRates[sd->getCodeRateLP()]);
                  static int GuardIntervals[] = { GUARD_INTERVAL_1_32, GUARD_INTERVAL_1_16, GUARD_INTERVAL_1_8, GUARD_INTERVAL_1_4 };
                  dtp.SetGuard(GuardIntervals[sd->getGuardInterval()]);
-                 static int TransmissionModes[] = { TRANSMISSION_MODE_2K, TRANSMISSION_MODE_8K, TRANSMISSION_MODE_AUTO, TRANSMISSION_MODE_AUTO };
+                 static int TransmissionModes[] = { TRANSMISSION_MODE_2K, TRANSMISSION_MODE_8K, TRANSMISSION_MODE_4K, TRANSMISSION_MODE_AUTO };
                  dtp.SetTransmission(TransmissionModes[sd->getTransmissionMode()]);
                  if (ThisNIT >= 0) {
                     for (int n = 0; n < NumFrequencies; n++) {
@@ -299,6 +303,40 @@
                     }
                  }
                  break;
+            case SI::ExtensionDescriptorTag: {
+                 SI::ExtensionDescriptor *sd = (SI::ExtensionDescriptor *)d;
+                 switch (sd->getExtensionDescriptorTag()) {
+                   case SI::T2DeliverySystemDescriptorTag: {
+                        if (Setup.UpdateChannels >= 5) {
+                           for (cChannel *Channel = Channels.First(); Channel; Channel = Channels.Next(Channel)) {
+                               int Source = cSource::FromData(cSource::stTerr);
+                               if (!Channel->GroupSep() && Channel->Source() == Source && Channel->Nid() == ts.getOriginalNetworkId() && Channel->Tid() == ts.getTransportStreamId()) {
+                                  SI::T2DeliverySystemDescriptor *td = (SI::T2DeliverySystemDescriptor *)d;
+                                  int Frequency = Channel->Frequency();
+                                  int SymbolRate = Channel->Srate();
+                                  //int SystemId = td->getSystemId();
+                                  cDvbTransponderParameters dtp(Channel->Parameters());
+                                  dtp.SetSystem(DVB_SYSTEM_2);
+                                  dtp.SetPlpId(td->getPlpId());
+                                  if (td->getExtendedDataFlag()) {
+                                     static int T2Bandwidths[] = { 8000000, 7000000, 6000000, 5000000, 10000000, 1712000, 0, 0 };
+                                     dtp.SetBandwidth(T2Bandwidths[td->getBandwidth()]);
+                                     static int T2GuardIntervals[] = { GUARD_INTERVAL_1_32, GUARD_INTERVAL_1_16, GUARD_INTERVAL_1_8, GUARD_INTERVAL_1_4, GUARD_INTERVAL_1_128, GUARD_INTERVAL_19_128, GUARD_INTERVAL_19_256, 0 };
+                                     dtp.SetGuard(T2GuardIntervals[td->getGuardInterval()]);
+                                     static int T2TransmissionModes[] = { TRANSMISSION_MODE_2K, TRANSMISSION_MODE_8K, TRANSMISSION_MODE_4K, TRANSMISSION_MODE_1K, TRANSMISSION_MODE_16K, TRANSMISSION_MODE_32K, TRANSMISSION_MODE_AUTO, TRANSMISSION_MODE_AUTO };
+                                     dtp.SetTransmission(T2TransmissionModes[td->getTransmissionMode()]);
+                                     //TODO add parsing of frequencies
+                                     }
+                                  Channel->SetTransponderData(Source, Frequency, SymbolRate, dtp.ToString('T'));
+                                  }
+                               }
+                           }
+                        }
+                        break;
+                   default: ;
+                   }
+                 }
+                 break;
             default: ;
             }
           delete d;
diff -ruN vdr-1.7.22/recording.c vdr-1.7.23/recording.c
--- vdr-1.7.22/recording.c	2011-12-04 14:51:44.000000000 +0100
+++ vdr-1.7.23/recording.c	2012-01-15 12:04:24.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recording.c 2.39 2011/12/04 13:51:44 kls Exp $
+ * $Id: recording.c 2.43 2012/01/15 11:04:24 kls Exp $
  */
 
 #include "recording.h"
@@ -873,16 +873,23 @@
         s++;
      else
         s = name;
-     titleBuffer = strdup(cString::sprintf("%02d.%02d.%02d%c%02d:%02d%c%d:%02d%c%c%s",
+     cString Length("");
+     if (NewIndicator) {
+        int Seconds = max(0, LengthInSeconds());
+        Length = cString::sprintf("%c%d:%02d",
+                   Delimiter,
+                   Seconds / 3600,
+                   Seconds / 60 % 60
+                   );
+        }
+     titleBuffer = strdup(cString::sprintf("%02d.%02d.%02d%c%02d:%02d%s%c%c%s",
                             t->tm_mday,
                             t->tm_mon + 1,
                             t->tm_year % 100,
                             Delimiter,
                             t->tm_hour,
                             t->tm_min,
-                            Delimiter,
-                            (LengthInSeconds() >= 0) ? LengthInSeconds() / 3600 : 0,
-                            (LengthInSeconds() >= 0) ? LengthInSeconds() / 60 % 60 : 0,
+                            *Length,
                             New,
                             Delimiter,
                             s));
@@ -1103,25 +1110,21 @@
   struct dirent *e;
   while ((Foreground || Running()) && (e = d.Next()) != NULL) {
         if (strcmp(e->d_name, ".") && strcmp(e->d_name, "..")) {
-           char *buffer = strdup(AddDirectory(DirName, e->d_name));
+           cString buffer = AddDirectory(DirName, e->d_name);
            struct stat st;
-           if (stat(buffer, &st) == 0) {
+           if (lstat(buffer, &st) == 0) {
               int Link = 0;
               if (S_ISLNK(st.st_mode)) {
                  if (LinkLevel > MAX_LINK_LEVEL) {
-                    isyslog("max link level exceeded - not scanning %s", buffer);
+                    isyslog("max link level exceeded - not scanning %s", *buffer);
                     continue;
                     }
                  Link = 1;
-                 char *old = buffer;
-                 buffer = ReadLink(old);
-                 free(old);
-                 if (!buffer)
+                 buffer = ReadLink(buffer);
+                 if (!*buffer)
                     continue;
-                 if (stat(buffer, &st) != 0) {
-                    free(buffer);
+                 if (stat(buffer, &st) != 0)
                     continue;
-                    }
                  }
               if (S_ISDIR(st.st_mode)) {
                  if (endswith(buffer, deleted ? DELEXT : RECEXT)) {
@@ -1144,7 +1147,6 @@
                     ScanVideoDir(buffer, Foreground, LinkLevel + Link);
                  }
               }
-           free(buffer);
            }
         }
 }
@@ -2040,15 +2042,18 @@
 
 cString IndexToHMSF(int Index, bool WithFrame, double FramesPerSecond)
 {
-  char buffer[16];
+  const char *Sign = "";
+  if (Index < 0) {
+     Index = -Index;
+     Sign = "-";
+     }
   double Seconds;
   int f = int(modf((Index + 0.5) / FramesPerSecond, &Seconds) * FramesPerSecond + 1);
   int s = int(Seconds);
   int m = s / 60 % 60;
   int h = s / 3600;
   s %= 60;
-  snprintf(buffer, sizeof(buffer), WithFrame ? "%d:%02d:%02d.%02d" : "%d:%02d:%02d", h, m, s, f);
-  return buffer;
+  return cString::sprintf(WithFrame ? "%s%d:%02d:%02d.%02d" : "%s%d:%02d:%02d", Sign, h, m, s, f);
 }
 
 int HMSFToIndex(const char *HMSF, double FramesPerSecond)
diff -ruN vdr-1.7.22/remux.c vdr-1.7.23/remux.c
--- vdr-1.7.22/remux.c	2011-09-04 15:09:06.000000000 +0200
+++ vdr-1.7.23/remux.c	2012-01-12 13:07:58.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: remux.c 2.62 2011/09/04 13:09:06 kls Exp $
+ * $Id: remux.c 2.63 2012/01/12 12:07:58 kls Exp $
  */
 
 #include "remux.h"
@@ -701,6 +701,10 @@
         uchar *p = data + offset - 6;
         if (p != data) {
            p -= 3;
+           if (p < data) {
+              Reset();
+              return NULL;
+              }
            memmove(p, data, 4);
            }
         int l = min(length - offset, MAXPESLENGTH);
diff -ruN vdr-1.7.22/svdrp.c vdr-1.7.23/svdrp.c
--- vdr-1.7.22/svdrp.c	2011-12-04 14:58:33.000000000 +0100
+++ vdr-1.7.23/svdrp.c	2012-01-12 16:02:46.000000000 +0100
@@ -10,7 +10,7 @@
  * and interact with the Video Disk Recorder - or write a full featured
  * graphical interface that sits on top of an SVDRP connection.
  *
- * $Id: svdrp.c 2.12 2011/12/04 13:58:33 kls Exp $
+ * $Id: svdrp.c 2.13 2012/01/12 15:02:46 kls Exp $
  */
 
 #include "svdrp.h"
@@ -583,6 +583,10 @@
                   }
                }
            if (Schedule) {
+              for (cTimer *Timer = Timers.First(); Timer; Timer = Timers.Next(Timer)) {
+                  if (ChannelID == Timer->Channel()->GetChannelID().ClrRid())
+                     Timer->SetEvent(NULL);
+                  }
               Schedule->Cleanup(INT_MAX);
               cEitFilter::SetDisableUntil(time(NULL) + EITDISABLETIME);
               Reply(250, "EPG data of channel \"%s\" cleared", Option);
